import { init, ECharts, use } from 'echarts/core';
import { SetOptionOpts, EChartsOption } from 'echarts';
import { FC, HTMLAttributes } from 'react';

type EChartsEventProp = 'onAxisAreaSelected' | 'onBrush' | 'onBrushEnd' | 'onBrushSelected' | 'onClick' | 'onContextMenu' | 'onDataRangeSelected' | 'onDataViewChanged' | 'onDataZoom' | 'onDoubleClick' | 'onDownplay' | 'onFinished' | 'onGeoSelectChanged' | 'onGeoSelected' | 'onGeoUnselected' | 'onGlobalCursorTaken' | 'onGlobalOut' | 'onHighlight' | 'onLegendInverseSelect' | 'onLegendScroll' | 'onLegendSelectChanged' | 'onLegendSelected' | 'onLegendUnselected' | 'onMagicTypeChanged' | 'onMouseDown' | 'onMouseMove' | 'onMouseOut' | 'onMouseOver' | 'onRendered' | 'onRestore' | 'onSelectChanged' | 'onTimelineChanged' | 'onTimelinePlayChanged';
type EChartEventsProps = {
    [K in EChartsEventProp]?: () => any;
};

type UseEChartsOptions = EChartEventsProps & SetOptionOpts & EChartsOption & Parameters<typeof init>[2] & {
    group?: ECharts['group'];
    theme?: Parameters<typeof init>[1];
    use?: Parameters<typeof use>[0];
};
declare function useECharts<T extends HTMLElement>({ devicePixelRatio, height, locale, pointerSize, renderer, theme, use, useCoarsePointer, useDirtyRect, width, group, lazyUpdate, notMerge, replaceMerge, silent, transition, darkMode, media, options, stateAnimation, angleAxis, animation, animationDelay, animationDelayUpdate, animationDuration, animationDurationUpdate, animationEasing, animationEasingUpdate, animationThreshold, aria, axisPointer, backgroundColor, blendMode, brush, calendar, color, dataZoom, dataset, geo, graphic, grid, hoverLayerThreshold, legend, parallel, parallelAxis, polar, progressive, progressiveThreshold, radar, radiusAxis, series, singleAxis, textStyle, timeline, title, toolbox, tooltip, useUTC, visualMap, xAxis, yAxis, onAxisAreaSelected, onBrush, onBrushEnd, onBrushSelected, onClick, onContextMenu, onDataRangeSelected, onDataViewChanged, onDataZoom, onDoubleClick, onDownplay, onFinished, onGeoSelectChanged, onGeoSelected, onGeoUnselected, onGlobalCursorTaken, onGlobalOut, onHighlight, onLegendInverseSelect, onLegendScroll, onLegendSelectChanged, onLegendSelected, onLegendUnselected, onMagicTypeChanged, onMouseDown, onMouseMove, onMouseOut, onMouseOver, onRendered, onRestore, onSelectChanged, onTimelineChanged, onTimelinePlayChanged }: UseEChartsOptions): [(node: T) => void, ECharts | undefined];

declare const useConnect: (group: string) => (boolean | ((connected: boolean) => void))[];

type ContainerProps = Omit<HTMLAttributes<HTMLDivElement>, 'onClick' | 'onDoubleClick' | 'onMouseDown' | 'onMouseMove' | 'onMouseOut' | 'onMouseOver'>;
type EChartProps = ContainerProps & UseEChartsOptions;
declare const EChart: FC<EChartProps>;

export { EChart, EChartProps, UseEChartsOptions, useConnect, useECharts };
